//
//  Copyright (C) 2004-2011 by Autodesk, Inc.
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of version 2.1 of the GNU Lesser
//  General Public License as published by the Free Software Foundation.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//
#pragma once

#ifndef _BUFFERPARAMS_
#define _BUFFERPARAMS_


/// \cond INTERNAL
struct OffsetParams
{
    bool m_doBuffer;            // true: CreateBuffer. false: CreateOffset
    bool m_keepCollinearPts;    // keep the collinear points in the result

    enum OffsetSide
    {
        Unset = -1,
        Right = 0,
        Left = 1,
        Cap = 2
    };

    OffsetSide m_side;      // valid when m_doBuffer is false;
    MgGeometry::OffsetExtType m_extType;

    OffsetParams()
        : m_doBuffer(true)
        , m_keepCollinearPts(false)
        , m_side(Unset)
        , m_extType(MgGeometry::kFillet)
    {
    }

    OffsetParams(bool buffer, bool collinear, OffsetSide side, MgGeometry::OffsetExtType extType)
        : m_doBuffer(buffer)
        , m_keepCollinearPts(collinear)
        , m_side(side)
        , m_extType(extType)
    {
    }
};

#endif // _BUFFERPARAMS_
