//
//  Copyright (C) 2004-2011 by Autodesk, Inc.
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of version 2.1 of the GNU Lesser
//  General Public License as published by the Free Software Foundation.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

#include "stdafx.h"
#include "Disposable.h"
#include "../Exception/Exception.h"

//////////////////////////////////////////////////////////////
int MgDisposable::GetRefCount()
{
    return m_refCount;
}


//////////////////////////////////////////////////////////////
int MgDisposable::AddRef()
{
    if (0 == m_refCount)
    {
        throw new MgException(L"Logic");
    }

    return ++m_refCount;
}


//////////////////////////////////////////////////////////////
int MgDisposable::Release()
{
    {
        if (0 >= m_refCount)
        {
            throw new MgException(L"Logic");
        }

        --m_refCount;

        if (0 != m_refCount)
        {
            return m_refCount;
        }
    }

    // if we get here, the reference count must be zero, so dispose of this object
    Dispose();
    return 0;
}


//////////////////////////////////////////////////////////////
MgDisposable::MgDisposable() :
    m_refCount(1)
{
}


//////////////////////////////////////////////////////////////
MgDisposable::~MgDisposable()
{
}
